﻿using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Linq;
using System.Threading.Tasks;
using Cascading_DropDownList_MVC_Core.Models;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;

namespace Cascading_DropDownList_MVC_Core.Controllers
{
    public class HomeController : Controller
    {
        private DBCtx Context { get; }
        public HomeController(DBCtx _context)
        {
            this.Context = _context;
        }

        public IActionResult Index()
        {
            CascadingModel model = new CascadingModel();
            model.Countries = (from customer in this.Context.Countries
                               select new SelectListItem
                               {
                                   Value = customer.CountryId.ToString(),
                                   Text = customer.CountryName
                               }).ToList();
            return View(model);
        }

        [HttpPost]
        public JsonResult AjaxMethod(string type, int value)
        {
            CascadingModel model = new CascadingModel();
            switch (type)
            {
                case "ddlCountries":
                    model.States = (from customer in this.Context.States
                                    where customer.CountryId == value
                                    select new SelectListItem
                                    {
                                        Value = customer.StateId.ToString(),
                                        Text = customer.StateName
                                    }).ToList();
                    break;
                case "ddlStates":
                    model.Cities = (from customer in this.Context.Cities
                                    where customer.StateId == value
                                    select new SelectListItem
                                    {
                                        Value = customer.CityId.ToString(),
                                        Text = customer.CityName
                                    }).ToList();
                    break;
            }
            return Json(model);
        }

        [HttpPost]
        public ActionResult Index(int countryId, int stateId, int cityId)
        {
            CascadingModel model = new CascadingModel();
            model.Countries = (from customer in this.Context.Countries
                               select new SelectListItem
                               {
                                   Value = customer.CountryId.ToString(),
                                   Text = customer.CountryName
                               }).ToList();

            model.States = (from customer in this.Context.States
                            where customer.CountryId == countryId
                            select new SelectListItem
                            {
                                Value = customer.StateId.ToString(),
                                Text = customer.StateName
                            }).ToList();

            model.Cities = (from customer in this.Context.Cities
                            where customer.StateId == stateId
                            select new SelectListItem
                            {
                                Value = customer.CityId.ToString(),
                                Text = customer.CityName
                            }).ToList();

            return View(model);
        }
    }
}